
' Temperaturregler fr 12 Volt Lfter mit Drehgeber zur Eingabe der Sollwerte
' und Anzeige ber LCD Display

' 19.06.2014
' Version 1N
' Funktion
' Lftersteurung
' ber Drerhgeber soll wenn Taste1 beim Einschalten festgehalten wird der obere
' und untere Temperatursollwert eingegeben werden.
' Bei erreichen der max Sollwert Temperatur soll eine Alarmmeldung aufs
' Display erscheinen und evtl Akustik Meldung
'
' Dafr stehen die Variablen Temp_min und Temp_max zur Verfgung
' Die Temperaturerfassung geschieht ber den I2C Sensor DS 1820
'

'--------------------- Allgemeine Prozessor Konfiguration ----------------------
$regfile "m8def.dat"     'Definiert den Atmega als Atmega8
$crystal = 1000000       'Gibt die Quarzfrequenz an in Herz
$hwstack = 64            'Default use 32 Hardware reservierte Speicher
$swstack = 50            'Default Software resvierung Speicher
'-------------------------------------------------------------------------------



'---------------------- Konfiguration frs Display------------------------------
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.5 , Db5 = Portb.4 , Db6 = Portb.3 , _
 Db7 = Portb.2 , Rs = Portd.1 , E = Portd.0
'--------------------------- Schnittstelle fr I2C Bus ------------------------
Config 1wire = Portc.5   'Schnitstelle Festlegen Fr Temp Sensor
Dim Ds1820 As Integer    'Integer Variabel fr Ds1820 setzen kann Daten - 32768 bis+32768 aufnehmen
'Dim T_wert As Byte



'--------------------------- Textzeichen erstellen ----------------------------
Deflcdchar 1 , 14 , 17 , 17 , 14 , 32 , 32 , 32 , 32       ' Zeichen fr Grad 
Cls


'--------------------------- I/O ----------------------------------------------
Ddrd.5 = 1               ' Als Ausgang setzen   Led Blau
Ddrd.6 = 1               ' Als Ausgang setzen   Led Rot
Ddrd.2 = 0               ' Als Eingang setzen Interrupt 0
Ddrd.3 = 0               ' Als Eingang setzen Interrupt 1
Ddrd.4 = 0               ' Als Eingang setzen Drehgeber Taster
Ddrc.3 = 1               ' Als Ausgang setzen fr Summer

Portd.2 = 1              ' PullUp setzen fr Portd.2
Portd.3 = 1              ' PullUp setzen fr Portd.3
Portd.4 = 1              ' Pull Up setzen fr Taster am drehgeber

'---------------------------- Variable -----------------------------------------
Dim Drehwert As Byte

Dim Temp_min As Byte

     ' Speicher fr sollwert der minimale temperatur
Dim Temp_min_eprom As Eram Byte

       ' Epromspeicher fr min temp sollwert

Dim Temp_max As Byte
Dim Temp_max_eprom As Eram Byte
Dim A As Byte            ' Fr strungsanzeige schleife fr led blinker
Dim Temperatur_differenz As Word

Dim Bit_grad As Byte
Dim B As Byte            ' fr schrittweite beim erhhenn und verringen des tastverhltnis
Dim Aus As Byte
Dim Stufe As Byte
Dim Sektor As Byte
Dim Temperatur As Byte
Dim C As Byte


'--------------------------- Timer 1 Konfiguration ---------------------------
Tccr1a = &B10000001
Tccr1b = &B00000001      ' voller takt wird genutzt
'Tccr1b = &B00000010      ' stetemtakt durch 8 geteilt display anzeige spinnt
'Tccr1b = &B00000011      ' takt durch 64 display spinnt
'Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Prescale =
Dim Tastverhaeltnis As Byte

Config Portb.1 = Output











'------------------------------ interrupt -----------------------------------
On Int0 Kanal0
On Int1 Kanal1

Mcucr = &B00001010       ' beide Interrupt reagieren auf wechsel von H nach L
Gicr = &B11000000        'int1 +  INT0 freigeben
Sreg = &B10000000        ' Global Interrupt freigeben
'---------------------------- Speicher kopieren -------------------------------
' holt die gespeicherten sollwert vorgabe aus dem Eprom und kopiert
' sie in ramspeicher
Temp_min = Temp_min_eprom
Waitms 20
Temp_max = Temp_max_eprom
Waitms 20
'------------------------- Einschaltmeldung ------------------------------------
Cls
Locate 1 , 1
Lcd "Drehgeber"
Locate 2 , 1
Lcd "Version 1N"
Wait 3
Cls







'---------------------------------- Vorgabewerte ------------------------------
'Tastverhaeltnis = 100    ' Vorgabe fr PWM  0 bis 255
'B = 1                    ' Vorgabe fr schrittweite beim verstellen des tastverhltnis
' wert 1-255 , Standar = 10




 Temperatur = 10











'-------------------------- Tastenabfrage zum Konfigurationmen ----------------
' Wenn Taster beim einschalten gedrckt dann ins Men wechseln
' wenn Taster nicht gedrckt dann ins Hauptprogramm springen
'If Pind.7 = 0 Then Gosub Sollwert Else Goto Hauptprogramm
If Pind.4 = 0 Then Gosub Sollwert Else Goto Hauptprogramm



'---------------------- H a u p  t p r o g r a m m ----------------------------                         Deflcdchar ?,14,17,17,14,32,32,32,32' replace ? with number (0-7)
Hauptprogramm:

'---------Ventilator mit Voller Drehzal anlaufen lassen im Startmoment---------
'Cls
Lcd "Fan Speed"
Portd.5 = 1
Tastverhaeltnis = 250
Compare1a = Tastverhaeltnis
Wait 2
Portd.5 = 0

'-----------------
Tastverhaeltnis = 125







Do

'For C = 1 To 30

'---- PWM ----Anfang
Compare1a = Tastverhaeltnis
 Waitms 10
 Temperatur = Ds1820


Toggle Portd.6


Cls
Locate 1 , 1
Lcd Temp_min
Locate 1 , 5
Lcd Chr(1)

Locate 1 , 11
Lcd Temp_max
Locate 1 , 16
Lcd Chr(1)

Locate 2 , 1
Lcd "Temp.=" ; Ds1820 ; Chr(1)

Locate 2 , 11
Lcd "Tv=" ; Tastverhaeltnis


'------------ Anfang Temp Sensor abfragen----


1wreset                  ' Der Bus wird resetiert


1wwrite &HCC             ' bersprimge Rom weil nur ein sensor angeschlossen
1wwrite &H44             ' Starte Temperaturmessung
Waitms 600               ' Pause von 900 millisekunden
' wenn pause zu kurz gibts falsche temperaturwerte aber nur beim einschalten
' 85
1wreset                  ' Reset DS1820
1wwrite &HCC             'berspringe Rom
1wwrite &HBE             ' sende inhalt der register AAH und 00h
Waitms 10

Ds1820 = 1wread(1)       'lese die empfangenen Daten
Waitms 10

1wreset                  'Reset Ds1820
Shift Ds1820 , Right     'entferne letztes bit


'---------- Ende Temp Sensor Abfrage ----------


Temperatur_differenz = Temperatur - Temp_min

If Temperatur_differenz < 1 Then Tastverhaeltnis = 1
If Temperatur_differenz > 0 Then Tastverhaeltnis = 2
If Temperatur_differenz > 1 Then Tastverhaeltnis = 4
If Temperatur_differenz > 2 Then Tastverhaeltnis = 5
If Temperatur_differenz > 3 Then Tastverhaeltnis = 10
If Temperatur_differenz > 4 Then Tastverhaeltnis = 20

If Temperatur_differenz > 5 Then Tastverhaeltnis = 50
If Temperatur_differenz > 6 Then Tastverhaeltnis = 240
If Temperatur_differenz > 100 Then Tastverhaeltnis = 1       ' negativer wert



 If Tastverhaeltnis > 253 Then Tastverhaeltnis = 254
 If Tastverhaeltnis < 2 Then Tastverhaeltnis = 1
'If Ds1820 > Temp_max Then Waitms 200
 'Next C

 If Ds1820 > Temp_max And Tastverhaeltnis > 230 Then Gosub Stoerung
  'If Tastverhaeltnis > 250 And Ds1820 > Temp_max Then Gosub Stoerung

Loop
Return

'_________________ Strungsanzeige bei bertemperatur ausgeben ----------------
Stoerung:
' Blaue Led soll aufblitzen und Meldung auf Display ausgeben + summer
For A = 1 To 3
    Portc.3 = 1          ' Summer an
    Waitms 500

   Portd.5 = 1           ' Led Blau an

   Waitms 20             ' Pause
   Portd.5 = 0           ' Led Blau aus
   Portc.3 = 0           ' Summer aus
   Waitms 100

Next A

   Cls                   ' Display lschen
Locate 1 , 1
Lcd " Uebertemperatur"
Locate 2 , 1
Lcd " ! ! ! ! ! ! ! ! "
Waitms 999

Return
'_______________________________________________________________________________











'------------------------- Interrupt 0 ----------------------------------------
Kanal0:
If Pind.2 = 0 And Pind.3 = 1 Then Drehwert = Drehwert -1

Portd.6 = 1              ' Led grn an
Waitms 20
Portd.6 = 0

Return
'------------------------- Interrupt 1 ----------------------------------------
'fr rechtsdrehung
Kanal1:
If Pind.3 = 0 And Pind.2 = 1 Then Drehwert = Drehwert + 1

Portb.0 = 1              ' Led Orange an
Waitms 20
Portb.0 = 0

Return
'-----------------------   Display --------------------------------------------
Anzeige:
Return

'-------------------------- Sollwerte eingeben ---------------------------------
Sollwert:
Cls
Locate 1 , 1
Lcd "Sollwerte eingeben"
Wait 2
'--------------
Do
Cls
Temp_min = Drehwert      ' Wert vom Drehgeber in Variable Temp_unten kopieren
Locate 1 , 1
Lcd "unter Temp."
Locate 2 , 1
Lcd Drehwert ; Chr(1)

Waitms 30

If Pind.4 = 0 Then Waitms 5
If Pind.4 = 0 Then Exit Do       'Schleife verlassen bei Tastendruck

Loop

'Daten sichern

Temp_min_eprom = Drehwert       ' kopiert min. tem vorgabe im eprom
Waitms 20

Portb.0 = 1
Waitms 200
Portb.0 = 0

'------------sollwerte temperatur maximum eingeben------------------------------
Cls
Locate 1 , 1
Lcd "Sollwerte eingeben"
Wait 2
'-----------
Do
Cls
 Temp_max = Drehwert
Locate 1 , 1
Lcd "obere Temp."
Locate 2 , 1
 Lcd Drehwert ; Chr(1)



 Waitms 30

If Pind.4 = 0 Then Waitms 5
If Pind.4 = 0 Then Exit Do

Loop

'Daten sichern

Temp_max_eprom = Drehwert       ' kopiert temp.max vorgabe im eprom
Waitms 20

Portb.0 = 1
Waitms 200
Portb.0 = 0


'------------------------------ E N D E ----------------------------------------